/**
 * A description of a worker.
 */
export default class Worker {
    /**
     * Creates a new worker description.
     *
     * @param name the identifier of the worker
     * @param hostname the name of the host the worker is running on
     * @param load the current load on the worker's machine
     * @param lastPing the timestamp the last ping was received
     * @param job the job the worker is currently serving
     */
    constructor(name, hostname, load, lastPing, job) {
        this.name = name;
        this.hostname = hostname;
        this.load = load;
        this.lastPing = lastPing;
        this.job = job;
        Object.freeze(this);
    }
}
