import Metric from "../src/Metric";
import EntityLevel from "../src/EntityLevel";
import Entity from "../src/Entity";

const SHALLOW_ENTITY = {"parent":null,"children":[],"name":"WriteToFile/3[HouseCatalog,String,String]","level":"METHOD","metrics":[{"value":31,"name":"LINES_OF_CODE"},{"value":0,"name":"COMPARISON_COUNT"},{"value":1,"name":"LOOP_COUNT"},{"value":3,"name":"PARAMETER_COUNT"},{"value":10,"name":"ASSIGNMENTS_COUNT"},{"value":14,"name":"RESPONSE_FOR_A_CLASS"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":2,"name":"WEIGHT_METHOD_CLASS"},{"value":10,"name":"VARIABLES_COUNT"},{"value":1,"name":"MAX_NESTED_BLOCKS"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":{"housecatalog":1,"amount":1,"address":4,"house":3,"stringhousenumber":1,"stringprice":1,"fw":2,"file":1,"bw":15,"stringstreet":1,"text":1,"stringnRooms":1,"stringzipCode":1,"stringcity":1},"name":"VARIABLES_USAGE"},{"value":{"stringsystem":1},"name":"FIELD_USAGE"},{"value":34,"name":"UNIQUE_WORDS_COUNT"},{"value":7,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":0,"name":"RETURN_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":4,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"WriteToFile/3[HouseCatalog,String,String]","reports":[],"testEntity":false};
const FULL_ENTITY = {"parent":null,"children":[{"parent":null,"children":[{"parent":null,"children":[{"parent":null,"children":[],"name":"giveCity/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":0,"name":"LOOP_COUNT"},{"value":1,"name":"VARIABLES_COUNT"},{"value":{"city":1},"name":"VARIABLES_USAGE"},{"value":2,"name":"RESPONSE_FOR_A_CLASS"},{"value":{"keyboard":1},"name":"FIELD_USAGE"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":1,"name":"WEIGHT_METHOD_CLASS"},{"value":1,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":0,"name":"MAX_NESTED_BLOCKS"},{"value":1,"name":"RETURN_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":1,"name":"ASSIGNMENTS_COUNT"},{"value":12,"name":"UNIQUE_WORDS_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":5,"name":"LINES_OF_CODE"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"giveCity/0","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"givePostalCode/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":0,"name":"LOOP_COUNT"},{"value":1,"name":"VARIABLES_COUNT"},{"value":2,"name":"RESPONSE_FOR_A_CLASS"},{"value":{"keyboard":1},"name":"FIELD_USAGE"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":1,"name":"WEIGHT_METHOD_CLASS"},{"value":1,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":0,"name":"MAX_NESTED_BLOCKS"},{"value":1,"name":"RETURN_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":1,"name":"ASSIGNMENTS_COUNT"},{"value":{"zipCode":1},"name":"VARIABLES_USAGE"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":5,"name":"LINES_OF_CODE"},{"value":11,"name":"UNIQUE_WORDS_COUNT"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"givePostalCode/0","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"WriteToFile/3[HouseCatalog,String,String]","level":"METHOD","metrics":[{"value":31,"name":"LINES_OF_CODE"},{"value":0,"name":"COMPARISON_COUNT"},{"value":1,"name":"LOOP_COUNT"},{"value":3,"name":"PARAMETER_COUNT"},{"value":10,"name":"ASSIGNMENTS_COUNT"},{"value":14,"name":"RESPONSE_FOR_A_CLASS"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":2,"name":"WEIGHT_METHOD_CLASS"},{"value":10,"name":"VARIABLES_COUNT"},{"value":1,"name":"MAX_NESTED_BLOCKS"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":{"housecatalog":1,"amount":1,"address":4,"house":3,"stringhousenumber":1,"stringprice":1,"fw":2,"file":1,"bw":15,"stringstreet":1,"text":1,"stringnRooms":1,"stringzipCode":1,"stringcity":1},"name":"VARIABLES_USAGE"},{"value":{"stringsystem":1},"name":"FIELD_USAGE"},{"value":34,"name":"UNIQUE_WORDS_COUNT"},{"value":7,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":0,"name":"RETURN_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":4,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"WriteToFile/3[HouseCatalog,String,String]","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"giveHouseNumber/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":{"housenumber":2},"name":"VARIABLES_USAGE"},{"value":0,"name":"LOOP_COUNT"},{"value":1,"name":"VARIABLES_COUNT"},{"value":2,"name":"RESPONSE_FOR_A_CLASS"},{"value":{"keyboard":1},"name":"FIELD_USAGE"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":1,"name":"WEIGHT_METHOD_CLASS"},{"value":1,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":0,"name":"MAX_NESTED_BLOCKS"},{"value":1,"name":"RETURN_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":6,"name":"LINES_OF_CODE"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":1,"name":"ASSIGNMENTS_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":11,"name":"UNIQUE_WORDS_COUNT"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"giveHouseNumber/0","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"readfile/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":0,"name":"LOOP_COUNT"},{"value":20,"name":"UNIQUE_WORDS_COUNT"},{"value":2,"name":"VARIABLES_COUNT"},{"value":4,"name":"RESPONSE_FOR_A_CLASS"},{"value":{},"name":"FIELD_USAGE"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":2,"name":"WEIGHT_METHOD_CLASS"},{"value":1,"name":"MAX_NESTED_BLOCKS"},{"value":1,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":2,"name":"RETURN_COUNT"},{"value":{"filename":1,"IO":2,"listOfHouses":1},"name":"VARIABLES_USAGE"},{"value":12,"name":"LINES_OF_CODE"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":1,"name":"TRY_CATCH_COUNT"},{"value":2,"name":"ASSIGNMENTS_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"readfile/0","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"givePrice/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":0,"name":"LOOP_COUNT"},{"value":1,"name":"VARIABLES_COUNT"},{"value":2,"name":"RESPONSE_FOR_A_CLASS"},{"value":{"keyboard":1},"name":"FIELD_USAGE"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":1,"name":"WEIGHT_METHOD_CLASS"},{"value":9,"name":"UNIQUE_WORDS_COUNT"},{"value":1,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":0,"name":"MAX_NESTED_BLOCKS"},{"value":1,"name":"RETURN_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":{"price":1},"name":"VARIABLES_USAGE"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":1,"name":"ASSIGNMENTS_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":5,"name":"LINES_OF_CODE"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"givePrice/0","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"giveStreet/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":0,"name":"LOOP_COUNT"},{"value":1,"name":"VARIABLES_COUNT"},{"value":2,"name":"RESPONSE_FOR_A_CLASS"},{"value":{"keyboard":1},"name":"FIELD_USAGE"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":1,"name":"WEIGHT_METHOD_CLASS"},{"value":1,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":{"street":1},"name":"VARIABLES_USAGE"},{"value":0,"name":"MAX_NESTED_BLOCKS"},{"value":1,"name":"RETURN_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":1,"name":"ASSIGNMENTS_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":10,"name":"UNIQUE_WORDS_COUNT"},{"value":5,"name":"LINES_OF_CODE"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"giveStreet/0","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"main/1[String[]]","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":1,"name":"PARAMETER_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"LOOP_COUNT"},{"value":0,"name":"VARIABLES_COUNT"},{"value":{"keyboard":1},"name":"FIELD_USAGE"},{"value":1,"name":"RESPONSE_FOR_A_CLASS"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":1,"name":"WEIGHT_METHOD_CLASS"},{"value":8,"name":"UNIQUE_WORDS_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":0,"name":"MAX_NESTED_BLOCKS"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":1,"name":"ASSIGNMENTS_COUNT"},{"value":0,"name":"RETURN_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":{"args":0},"name":"VARIABLES_USAGE"},{"value":0,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"NUMBER_COUNT"},{"value":4,"name":"LINES_OF_CODE"}],"fullName":"main/1[String[]]","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"giveHeatingsystem/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":7,"name":"ASSIGNMENTS_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":5,"name":"WEIGHT_METHOD_CLASS"},{"value":23,"name":"UNIQUE_WORDS_COUNT"},{"value":0,"name":"LOOP_COUNT"},{"value":{"keyboard":1,"stringsystem":3},"name":"FIELD_USAGE"},{"value":2,"name":"VARIABLES_COUNT"},{"value":22,"name":"LINES_OF_CODE"},{"value":3,"name":"RESPONSE_FOR_A_CLASS"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":0,"name":"MAX_NESTED_BLOCKS"},{"value":1,"name":"RETURN_COUNT"},{"value":{"system":4,"heatingChoice":1},"name":"VARIABLES_USAGE"},{"value":5,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":1,"name":"NUMBER_COUNT"}],"fullName":"giveHeatingsystem/0","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"loop/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":192,"name":"LINES_OF_CODE"},{"value":{"keyboard":8},"name":"FIELD_USAGE"},{"value":115,"name":"UNIQUE_WORDS_COUNT"},{"value":23,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":2,"name":"MAX_NESTED_BLOCKS"},{"value":53,"name":"ASSIGNMENTS_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":39,"name":"VARIABLES_COUNT"},{"value":25,"name":"RESPONSE_FOR_A_CLASS"},{"value":11,"name":"NUMBER_COUNT"},{"value":12,"name":"LOOP_COUNT"},{"value":47,"name":"WEIGHT_METHOD_CLASS"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":7,"name":"COMPARISON_COUNT"},{"value":0,"name":"RETURN_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":{"rentaddress":1,"pricebuy":1,"textbuy":4,"housenumberrent":1,"saleorrent":1,"buyaddress":1,"streetbuy":1,"chosenlist":2,"house":39,"buyhouse":1,"rentalhouses":2,"chosenprice":4,"housenumberbuy":1,"textchoicerent":1,"scanner":2,"nRoomsrent":1,"renthouse":1,"pricerent":1,"textrent":4,"zipCoderent":1,"buyhouses":3,"amount":4,"energylabel":8,"nRoomsbuy":1,"zipCodebuy":1,"availablebuy":4,"citybuy":1,"saleorrentlist":4,"availablechoicelist":4,"allhouses":14,"streetrent":1,"availablerent":4,"cityrent":1,"systemrent":1,"stringamount":3,"availablechoice":1,"systembuy":1,"choice":1,"textchoicebuy":1,"energylabellist":10},"name":"VARIABLES_USAGE"}],"fullName":"loop/0","reports":[],"testEntity":false},{"parent":null,"children":[],"name":"giveNRooms/0","level":"METHOD","metrics":[{"value":0,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"COMPARISON_COUNT"},{"value":0,"name":"PARAMETER_COUNT"},{"value":0,"name":"LOOP_COUNT"},{"value":1,"name":"VARIABLES_COUNT"},{"value":2,"name":"RESPONSE_FOR_A_CLASS"},{"value":{"keyboard":1},"name":"FIELD_USAGE"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":1,"name":"WEIGHT_METHOD_CLASS"},{"value":1,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":0,"name":"MAX_NESTED_BLOCKS"},{"value":{"nRooms":1},"name":"VARIABLES_USAGE"},{"value":1,"name":"RETURN_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":1,"name":"ASSIGNMENTS_COUNT"},{"value":15,"name":"UNIQUE_WORDS_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":5,"name":"LINES_OF_CODE"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"giveNRooms/0","reports":[],"testEntity":false}],"name":"HousingApplication","level":"CLASS","metrics":[{"value":2,"name":"STATIC_FIELD_COUNT"},{"value":318,"name":"LINES_OF_CODE"},{"value":15,"name":"COUPLING_BETWEEN_OBJECTS"},{"value":1,"name":"DEPTH_INHERITANCE_TREE"},{"value":0,"name":"SYNCHRONIZED_FIELD_COUNT"},{"value":0,"name":"ABSTRACT_METHOD_COUNT"},{"value":63,"name":"WEIGHT_METHOD_CLASS"},{"value":11,"name":"PUBLIC_METHOD_COUNT"},{"value":0,"name":"DEFAULT_METHOD_COUNT"},{"value":9,"name":"RETURN_COUNT"},{"value":61,"name":"VARIABLES_COUNT"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":0,"name":"LACK_OF_COHESION_OF_METHODS"},{"value":37,"name":"RESPONSE_FOR_A_CLASS"},{"value":2,"name":"MAX_NESTED_BLOCKS"},{"value":11,"name":"METHOD_COUNT"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":1,"name":"TRY_CATCH_COUNT"},{"value":2,"name":"FIELD_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":0,"name":"PRIVATE_METHOD_COUNT"},{"value":2,"name":"PRIVATE_FIELD_COUNT"},{"value":25,"name":"NUMBER_OF_STATIC_INVOCATIONS"},{"value":42,"name":"STRING_LITERAL_COUNT"},{"value":11,"name":"STATIC_METHOD_COUNT"},{"value":0,"name":"DEFAULT_FIELD_COUNT"},{"value":0,"name":"PROTECTED_FIELD_COUNT"},{"value":79,"name":"ASSIGNMENTS_COUNT"},{"value":0,"name":"SYNCHRONIZED_METHOD_COUNT"},{"value":0,"name":"FINAL_METHOD_COUNT"},{"value":12,"name":"NUMBER_COUNT"},{"value":13,"name":"LOOP_COUNT"},{"value":163,"name":"UNIQUE_WORDS_COUNT"},{"value":0,"name":"PROTECTED_METHOD_COUNT"},{"value":0,"name":"PUBLIC_FIELD_COUNT"},{"value":7,"name":"COMPARISON_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":0,"name":"FINAL_FIELD_COUNT"},{"value":4,"name":"MATH_OPERATIONS_COUNT"}],"fullName":"HousingApplication","reports":[],"testEntity":false}],"name":"HousingApplication.java","level":"FILE","metrics":[],"fullName":"HousingApplication.java","reports":[],"testEntity":false}],"name":"root","level":"PROJECT","metrics":[],"fullName":"root","reports":[],"testEntity":false};

test('shallow parse', () => {
    const entity = Entity.parse(SHALLOW_ENTITY);

    expect(entity.parent).toBeFalsy();
    expect(entity.name).toEqual(SHALLOW_ENTITY.name);
    expect(entity.level).toEqual(EntityLevel.METHOD);
    expect(entity.testEntity).toBeFalsy();
    expect(entity.reports).toHaveLength(0);
    expect(entity.children).toHaveLength(0);
    expect(entity.metrics[2]).toBeInstanceOf(Metric);
    expect(entity.metrics[2]).toEqual(new Metric('LOOP_COUNT', 1));
});

test('deep parse', () => {
    const entity = Entity.parse(FULL_ENTITY);

    expect(entity.children[0].parent).toBe(entity);
});

test('deep parse with traversal using generator', () => {
    expect.hasAssertions();

    const entity = Entity.parse(FULL_ENTITY);

    let numAsserts = 0;
    for (const child of entity.childGenerator()) {
        expect(child.testProperty).toBeUndefined();
        child.testProperty = 'set';
        ++numAsserts;
    }
});

test('deep parse with full name of nested entity', () => {
    const entity = Entity.parse(FULL_ENTITY);

    expect(entity.children[0].children[0].children[0].getFullName()).toEqual(
        'root/HousingApplication.java/HousingApplication/giveCity/0'
    );
});

test('shallow parse with toString', () => {
    const entity = Entity.parse(SHALLOW_ENTITY);
    expect(entity.toString()).toEqual(
        "METHOD:[WriteToFile/3[HouseCatalog,String,String]][LINES_OF_CODE](31),[COMPARISON_COUNT](0),[LOOP_COUNT](1),[PARAMETER_COUNT](3),[ASSIGNMENTS_COUNT](10),[RESPONSE_FOR_A_CLASS](14),[SUBCLASSES_COUNT](0),[WEIGHT_METHOD_CLASS](2),[VARIABLES_COUNT](10),[MAX_NESTED_BLOCKS](1),[PARENTHESIZED_EXPRESSION_COUNT](0),[VARIABLES_USAGE]({\"housecatalog\":1,\"amount\":1,\"address\":4,\"house\":3,\"stringhousenumber\":1,\"stringprice\":1,\"fw\":2,\"file\":1,\"bw\":15,\"stringstreet\":1,\"text\":1,\"stringnRooms\":1,\"stringzipCode\":1,\"stringcity\":1}),[FIELD_USAGE]({\"stringsystem\":1}),[UNIQUE_WORDS_COUNT](34),[STRING_LITERAL_COUNT](7),[TRY_CATCH_COUNT](0),[ANONYMOUS_CLASSES_COUNT](0),[RETURN_COUNT](0),[LAMBDAS_COUNT](0),[MATH_OPERATIONS_COUNT](4),[NUMBER_COUNT](0)()"
    );
});

test('parse null', () => {
    const entity = Entity.parse(null);
    expect(entity).toBeNull();
});
