import Submission from '../src/Submission';

const SHALLOW_ENTITY = {"parent":null,"children":[],"name":"WriteToFile/3[HouseCatalog,String,String]","level":"METHOD","metrics":[{"value":31,"name":"LINES_OF_CODE"},{"value":0,"name":"COMPARISON_COUNT"},{"value":1,"name":"LOOP_COUNT"},{"value":3,"name":"PARAMETER_COUNT"},{"value":10,"name":"ASSIGNMENTS_COUNT"},{"value":14,"name":"RESPONSE_FOR_A_CLASS"},{"value":0,"name":"SUBCLASSES_COUNT"},{"value":2,"name":"WEIGHT_METHOD_CLASS"},{"value":10,"name":"VARIABLES_COUNT"},{"value":1,"name":"MAX_NESTED_BLOCKS"},{"value":0,"name":"PARENTHESIZED_EXPRESSION_COUNT"},{"value":{"housecatalog":1,"amount":1,"address":4,"house":3,"stringhousenumber":1,"stringprice":1,"fw":2,"file":1,"bw":15,"stringstreet":1,"text":1,"stringnRooms":1,"stringzipCode":1,"stringcity":1},"name":"VARIABLES_USAGE"},{"value":{"stringsystem":1},"name":"FIELD_USAGE"},{"value":34,"name":"UNIQUE_WORDS_COUNT"},{"value":7,"name":"STRING_LITERAL_COUNT"},{"value":0,"name":"TRY_CATCH_COUNT"},{"value":0,"name":"ANONYMOUS_CLASSES_COUNT"},{"value":0,"name":"RETURN_COUNT"},{"value":0,"name":"LAMBDAS_COUNT"},{"value":4,"name":"MATH_OPERATIONS_COUNT"},{"value":0,"name":"NUMBER_COUNT"}],"fullName":"WriteToFile/3[HouseCatalog,String,String]","reports":[],"testEntity":false};

test('getVerdict forwards to client', () => {
    const testAid = 'test assignment';
    const testSid = 'test submission ID';

    const testVerdict = 'fail';

    const client = {
        async getVerdict(aid, sid) {
            expect(aid).toEqual(testAid);
            expect(sid).toEqual(testSid);
            return testVerdict;
        }
    };

    const submission = new Submission(testAid, testSid, 'name', null, client);
    submission.getVerdict().then(verdict => expect(verdict).toEqual(testVerdict));
});

test('getEntity forwards to client', () => {
    const testAid = 'test assignment ID';
    const testSid = 'test submission identifier';

    const client = {
        async getSubmission(aid, sid) {
            expect(aid).toEqual(testAid);
            expect(sid).toEqual(testSid);
            const sub = new Submission('bad', 'no', 'also bad', null, this);
            sub.entity = SHALLOW_ENTITY;
            return sub;
        }
    };

    const submission = new Submission(testAid, testSid, 'name', null, client);
    return submission.getEntity().then(entity => {
        expect(entity).toEqual(SHALLOW_ENTITY);
        expect(submission.entity).toEqual(SHALLOW_ENTITY);
        expect(submission.name).toEqual('name');
    });
});
