const path = require('path');
const webpack = require("webpack");

class Target {
    constructor(name) {
        this.mode = 'production';
        this.target = name;
        this.entry = `./src/backend/${name}/${name}.js`;
        this.output = {
            filename: `auta.${name}.js`,
            path: path.resolve(__dirname, 'dist'),
            library: 'auta',
            libraryTarget: 'umd'
        };
        this.devtool = 'source-map';
        this.plugins = [
            new webpack.DefinePlugin({
                VERSION: JSON.stringify(require('./package.json').version)
            })
        ];
    }
}

module.exports = [new Target('node'), new Target('web')];
